com.io7m.jtensors

## Class VectorI2F

- java.lang.Object
- - com.io7m.jtensors.VectorI2F

- All Implemented Interfaces:
    VectorReadable2FType

      @Immutable
      public final class VectorI2F
      extends Object
      implements VectorReadable2FType

  A two-dimensional immutable vector type with `float` elements.

  Values of this type are immutable and can therefore be safely accessed from multiple threads.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static VectorI2F` | `ZERO` The zero vector.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `VectorI2F()` Default constructor, initializing the vector with values `[0.0, 0.0]`.
    `VectorI2F(float in_x, float in_y)` Construct a vector initialized with the given values.
    `VectorI2F(VectorReadable2FType in_v)` Construct a vector initialized with the values given in the vector `v`.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static VectorI2F` | `absolute(VectorReadable2FType v)` Calculate the absolute value of the vector `v`.
    `static VectorI2F` | `add(VectorReadable2FType v0, VectorReadable2FType v1)` Calculate the element-wise sum of the vectors `v0` and `v1`.
    `static VectorI2F` | `addScaled(VectorReadable2FType v0, VectorReadable2FType v1, double r)` Calculate the element-wise sum of the vectors `v0` and the element-wise product of `v1` and `r`.
    `static boolean` | `almostEqual(com.io7m.jequality.AlmostEqualFloat.ContextRelative context, VectorReadable2FType qa, VectorReadable2FType qb)` Determine whether or not the vectors `qa` and `qb` are equal to within the degree of error given in `context`.
    `static double` | `angle(VectorReadable2FType v0, VectorReadable2FType v1)` Calculate the angle between the vectors `v0` and `v1` in radians.
    `static VectorI2F` | `clamp(VectorReadable2FType v, float minimum, float maximum)` Clamp the elements of the vector `v` to the range {@code [minimum ..
    `static VectorI2F` | `clampByVector(VectorReadable2FType v, VectorReadable2FType minimum, VectorReadable2FType maximum)` Clamp the elements of the vector `v` to the inclusive range given by the corresponding elements in `minimum` and `maximum`.
    `static VectorI2F` | `clampMaximum(VectorReadable2FType v, float maximum)` Clamp the elements of the vector `v` to the range {@code [-Infinity ..
    `static VectorI2F` | `clampMaximumByVector(VectorReadable2FType v, VectorReadable2FType maximum)` Clamp the elements of the vector `v` to the inclusive range given by the corresponding elements in `maximum`.
    `static VectorI2F` | `clampMinimum(VectorReadable2FType v, float minimum)` Clamp the elements of the vector `v` to the range {@code [minimum ..
    `static VectorI2F` | `clampMinimumByVector(VectorReadable2FType v, VectorReadable2FType minimum)` Clamp the elements of the vector `v` to the inclusive range given by the corresponding elements in `minimum`.
    `static double` | `distance(VectorReadable2FType v0, VectorReadable2FType v1)` Calculate the distance between the two vectors `v0` and `v1`.
    `static double` | `dotProduct(VectorReadable2FType v0, VectorReadable2FType v1)` Calculate the scalar product of the vectors `v0` and `v1`.
    `boolean` | `equals(Object obj)`
    `float` | `getXF()`
    `float` | `getYF()`
    `int` | `hashCode()`
    `static VectorI2F` | `interpolateLinear(VectorReadable2FType v0, VectorReadable2FType v1, float alpha)` Linearly interpolate between `v0` and `v1` by the amount `alpha`.
    `static double` | `magnitude(VectorReadable2FType v)` Calculate the magnitude of the vector `v`.
    `static double` | `magnitudeSquared(VectorReadable2FType v)` Calculate the squared magnitude of the vector `v`.
    `static VectorI2F` | `normalize(VectorReadable2FType v)` Normalize the vector `v`, preserving its direction but reducing it to unit length.
    `static com.io7m.jfunctional.Pair<VectorI2F,VectorI2F>` | `orthoNormalize(VectorReadable2FType v0, VectorReadable2FType v1)` Orthonormalize and return the vectors `v0` and `v1` .
    `static VectorI2F` | `projection(VectorReadable2FType p, VectorReadable2FType q)` Calculate the projection of the vector `p` onto the vector `q`.
    `static VectorI2F` | `scale(VectorReadable2FType v, double r)` Scale the vector `v` by the scalar `r`.
    `static VectorI2F` | `subtract(VectorReadable2FType v0, VectorReadable2FType v1)` Subtract the vector `v1` from the vector `v0`.
    `String` | `toString()`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### ZERO

          public static final VectorI2F ZERO

      The zero vector.

  - ### Constructor Detail

    - #### VectorI2F

          public VectorI2F()

      Default constructor, initializing the vector with values `[0.0, 0.0]`.

    - #### VectorI2F

          public VectorI2F(float in_x,
                           float in_y)

      Construct a vector initialized with the given values.
      Parameters:
        `in_x` - The `x` value
        `in_y` - The `y` value

    - #### VectorI2F

          public VectorI2F(VectorReadable2FType in_v)

      Construct a vector initialized with the values given in the vector `v`.
      Parameters:
        `in_v` - The input vector

  - ### Method Detail

    - #### absolute

          public static VectorI2F absolute(VectorReadable2FType v)

      Calculate the absolute value of the vector `v`.
      Parameters:
        `v` - The input vector
      Returns:
        `(abs v.x, abs v.y)`

    - #### add

          public static VectorI2F add(VectorReadable2FType v0,
                                      VectorReadable2FType v1)

      Calculate the element-wise sum of the vectors `v0` and `v1`.
      Parameters:
        `v0` - The left input vector
        `v1` - The right input vector
      Returns:
        `(v0.x + v1.x, v0.y + v1.y)`

    - #### addScaled

          public static VectorI2F addScaled(VectorReadable2FType v0,
                                            VectorReadable2FType v1,
                                            double r)

      Calculate the element-wise sum of the vectors `v0` and the element-wise product of `v1` and `r`.
      Parameters:
        `v0` - The left input vector
        `v1` - The right input vector
        `r` - The scaling value
      Returns:
        `(v0.x + (v1.x * r), v0.y + (v1.y * r))`

    - #### almostEqual

          public static boolean almostEqual(com.io7m.jequality.AlmostEqualFloat.ContextRelative context,
                                            VectorReadable2FType qa,
                                            VectorReadable2FType qb)

      Determine whether or not the vectors `qa` and `qb` are equal to within the degree of error given in `context`.
      Parameters:
        `context` - The equality context
        `qa` - The left input vector
        `qb` - The right input vector
      Returns:
        `true` iff the vectors are almost equal.
      Since:
        5.0.0
      See Also:
        `AlmostEqualFloat.almostEqual(ContextRelative, float, float)`

    - #### angle

          public static double angle(VectorReadable2FType v0,
                                     VectorReadable2FType v1)

      Calculate the angle between the vectors `v0` and `v1` in radians.
      Parameters:
        `v0` - The left input vector
        `v1` - The right input vector
      Returns:
        The angle between the two vectors, in radians.

    - #### clamp

          public static VectorI2F clamp(VectorReadable2FType v,
                                        float minimum,
                                        float maximum)

      Clamp the elements of the vector `v` to the range `[minimum .. maximum]` inclusive.
      Parameters:
        `v` - The input vector
        `minimum` - The minimum allowed value
        `maximum` - The maximum allowed value
      Returns:
        A vector with both elements equal to at most `maximum` and at least `minimum`.

    - #### clampByVector

          public static VectorI2F clampByVector(VectorReadable2FType v,
                                                VectorReadable2FType minimum,
                                                VectorReadable2FType maximum)

      Clamp the elements of the vector `v` to the inclusive range given by the corresponding elements in `minimum` and `maximum`.
      Parameters:
        `v` - The input vector
        `minimum` - The vector containing the minimum acceptable values
        `maximum` - The vector containing the maximum acceptable values
      Returns:
        `(min(max(v.x, minimum.x), maximum.x), min(max(v.y, minimum.y), maximum.y))`

    - #### clampMaximum

          public static VectorI2F clampMaximum(VectorReadable2FType v,
                                               float maximum)

      Clamp the elements of the vector `v` to the range `[-Infinity .. maximum]` inclusive.
      Parameters:
        `v` - The input vector
        `maximum` - The maximum allowed value
      Returns:
        A vector with both elements equal to at most `maximum`

    - #### clampMaximumByVector

          public static VectorI2F clampMaximumByVector(VectorReadable2FType v,
                                                       VectorReadable2FType maximum)

      Clamp the elements of the vector `v` to the inclusive range given by the corresponding elements in `maximum`.
      Parameters:
        `v` - The input vector
        `maximum` - The vector containing the maximum acceptable values
      Returns:
        `(min(v.x, maximum.x), min(v.y, maximum.y))`

    - #### clampMinimum

          public static VectorI2F clampMinimum(VectorReadable2FType v,
                                               float minimum)

      Clamp the elements of the vector `v` to the range `[minimum .. Infinity]` inclusive.
      Parameters:
        `v` - The input vector
        `minimum` - The minimum allowed value
      Returns:
        A vector with both elements equal to at least `minimum`

    - #### clampMinimumByVector

          public static VectorI2F clampMinimumByVector(VectorReadable2FType v,
                                                       VectorReadable2FType minimum)

      Clamp the elements of the vector `v` to the inclusive range given by the corresponding elements in `minimum`.
      Parameters:
        `v` - The input vector
        `minimum` - The vector containing the minimum acceptable values
      Returns:
        `(max(v.x, minimum.x), max(v.y, minimum.y))`

    - #### distance

          public static double distance(VectorReadable2FType v0,
                                        VectorReadable2FType v1)

      Calculate the distance between the two vectors `v0` and `v1`.
      Parameters:
        `v0` - The left input vector
        `v1` - The right input vector
      Returns:
        The distance between the two vectors

    - #### dotProduct

          public static double dotProduct(VectorReadable2FType v0,
                                          VectorReadable2FType v1)

      Calculate the scalar product of the vectors `v0` and `v1`.
      Parameters:
        `v0` - The left input vector
        `v1` - The right input vector
      Returns:
        The scalar product of the two vectors

    - #### interpolateLinear

          public static VectorI2F interpolateLinear(VectorReadable2FType v0,
                                                    VectorReadable2FType v1,
                                                    float alpha)

      Linearly interpolate between `v0` and `v1` by the amount `alpha`. The `alpha` parameter controls the degree of interpolation, such that:
      - `interpolateLinear(v0, v1, 0.0) = v0`
      - `interpolateLinear(v0, v1, 1.0) = v1`
      Parameters:
        `v0` - The left input vector.
        `v1` - The right input vector.
        `alpha` - The interpolation value, between `0.0` and `1.0`.
      Returns:
        `(1 - alpha) * v0 + alpha * v1`

    - #### magnitude

          public static double magnitude(VectorReadable2FType v)

      Calculate the magnitude of the vector `v`. Correspondingly, `magnitude(normalize(v)) == 1.0`.
      Parameters:
        `v` - The input vector
      Returns:
        The magnitude of the input vector

    - #### magnitudeSquared

          public static double magnitudeSquared(VectorReadable2FType v)

      Calculate the squared magnitude of the vector `v`.
      Parameters:
        `v` - The input vector
      Returns:
        The squared magnitude of the input vector

    - #### normalize

          public static VectorI2F normalize(VectorReadable2FType v)

      Normalize the vector `v`, preserving its direction but reducing it to unit length.
      Parameters:
        `v` - The input vector
      Returns:
        A vector with the same orientation as `v` but with magnitude equal to `1.0`

    - #### orthoNormalize

          public static com.io7m.jfunctional.Pair<VectorI2F,VectorI2F> orthoNormalize(VectorReadable2FType v0,
                                                                                      VectorReadable2FType v1)

      Orthonormalize and return the vectors `v0` and `v1` .

      See GSP

      Parameters:
        `v0` - The left vector
        `v1` - The right vector
      Returns:
        A pair `(v0, v1)`, orthonormalized.
      Since:
        5.0.0

    - #### projection

          public static VectorI2F projection(VectorReadable2FType p,
                                             VectorReadable2FType q)

      Calculate the projection of the vector `p` onto the vector `q`.
      Parameters:
        `p` - The left vector
        `q` - The right vector
      Returns:
        `((dotProduct p q) / magnitudeSquared q) * q`

    - #### scale

          public static VectorI2F scale(VectorReadable2FType v,
                                        double r)

      Scale the vector `v` by the scalar `r`.
      Parameters:
        `v` - The input vector
        `r` - The scaling value
      Returns:
        `(v.x * r, v.y * r)`

    - #### subtract

          public static VectorI2F subtract(VectorReadable2FType v0,
                                           VectorReadable2FType v1)

      Subtract the vector `v1` from the vector `v0`.
      Parameters:
        `v0` - The left input vector
        `v1` - The right input vector
      Returns:
        `(v0.x - v1.x, v0.y - v1.y)`

    - #### equals

          public boolean equals(@Nullable
                                Object obj)

      Overrides:
        `equals` in class `Object`

    - #### getXF

          public float getXF()

      Specified by:
        `getXF` in interface `VectorReadable2FType`
      Returns:
        The X value of the given vector.

    - #### getYF

          public float getYF()

      Specified by:
        `getYF` in interface `VectorReadable2FType`
      Returns:
        The Y value of the given vector.

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `Object`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

Copyright © 2015 <code@io7m.com> http://io7m.com